*! NJC 3.0.3 7 Sept 2009 
* NJC 3.0.2 14 April 2009 
* NJC 3.0.1 13 April 2009 
* NJC 3.0.0 6 April 2009 
* NJC 2.1.0 6 August 2004 
* NJC 2.0.1 2 April 2004
* NJC 2.0.0 9 January 2004
* NJC 1.1.1 23 December 1998
* NJC 1.1.0 16 December 1998
* NJC 1.0.0 9 May 1997
* raw data plot for circular data with point symbols
program circdplot, sort 
	version 9   
	syntax varname(numeric) [if] [in] [, ///
	Width(real 0) Height(numlist max=1 >0) unit(numlist max=1 >=1) ///
	RESULTant(str asis) DEGree(int 176) REVerse /// 
	CLAbel(str asis) CTICk(numlist) CTICKLength(real 0.05) COMPASS(str asis) /// 
	CIRCLE(str asis) BY(str) SAVING(str asis) * ]

	// check if data to plot
	marksample touse

	if `"`by'"' != "" { 
		Parseby `by' 
		markout `touse' `byvar', strok 
	} 

	qui count if `touse' 
	if r(N) == 0 error 2000 

	// group(s) 
	tempvar group
	qui if `"`by'"' != "" { 
		egen `group' = group(`byvar') if `touse', label  
		su `group', meanonly 
		local ng = r(max) 
	} 
	else { 
		gen byte `group' = `touse' 
		local ng = 1 
	}

	// compass labels and ticks 	
	if trim(`"`clabel'"') == "" { 
		local clabel `"0 "N" 90 "E" 180 "S" 270 "W""' 
		Clabelparse `clabel' 
	} 
	else if trim("`clabel'") != "none" {
		if index(`"`clabel'"', `"""') Clabelparse `clabel' 
		else { 
			capture numlist `"`clabel'"' 
			if _rc Clabelparse `clabel' 
			else   Clabelparse `r(numlist)' 
		}	
	} 	
	else local clabel 

	local f = 1 - `cticklength' 
	if `"`clabel'"' != "" {
		local k = 1 
			
		foreach c of local clabelnumb { 
			local x = sin(`c' * _pi/180) 
			local y = cos(`c' * _pi/180)
			local fx = `f' * `x' 
			local fy = `f' * `y' 
				
			local ctickcall `ctickcall' `y' `x' `fy' `fx'

			local K : word `k++' of `clabeltext' 
			Compasspoint C `c' 
			local addtext ///
			`"`addtext' text(`fy' `fx' "`K'", color(blue) place(`C'))"' 
		}	
	} 

	if "`ctick'" != "" {
		foreach c of local ctick { 
			local x = sin(`c' * _pi/180) 
			local y = cos(`c' * _pi/180)
			local fx = `f' * `x' 
			local fy = `f' * `y' 
			
			local ctickcall `ctickcall' `y' `x' `fy' `fx'
		}	
	} 	

	tempvar xsum ysum work freq doty dotx 
	tempname XSUM YSUM vecmean veclng vecstr

	qui {
		// trigonometry 
		bysort `touse' `group': gen `xsum' = sum(sin((`varlist'*_pi)/180))
		by `touse' `group': replace `xsum' = `xsum'[_N]
		by `touse' `group': gen `ysum' = sum(cos((`varlist'*_pi)/180))
		by `touse' `group': replace `ysum' = `ysum'[_N]

		// rounding to bins: default 0 deg (before 3.0.0 was: 1 deg) 
		gen `work' = round(`varlist',`width')
		replace `work' = 0 if `work' == 360
		local varlist `work' 

		// coordinates of point symbols 
		bysort `touse' `group' `varlist': gen `freq' = _N if `touse' 
		if "`unit'" != "" & "`unit'" != "1" { 
			by `touse' `group' `varlist' : replace `freq' = ///
				        ceil(_N / `unit') if `touse' 
			by `touse' `group' `varlist' : replace `freq' = . if _n > `freq'[_N]
		}

 		su `freq', meanonly
		if "`height'" == "" local height = min(1, r(max) / 10) 
		local size = 1.1 + `height' 
		by `touse' `group' `varlist': replace `freq' = 1 + _n * `height' / r(max) if `freq' < . 
		gen `doty' = `freq' * cos((`varlist'*_pi)/180) 
		gen `dotx' = `freq' * sin((`varlist'*_pi)/180)  

		// separate graphs for each group 
		forval g = 1/`ng' { 
			su `xsum' if `group' == `g', meanonly 
			scalar `XSUM' = r(max)
			su `ysum' if `group' == `g', meanonly 
			scalar `YSUM' = r(max)
			local N = r(N) 

			Atan2 `XSUM' `YSUM'
			scalar `vecmean' = r(angle) 
			scalar `veclng' = sqrt((`XSUM')^2 + (`YSUM')^2)
			scalar `vecstr' = `veclng' / `N' 
	
		       	local sub1 : di "mean " %03.0f `vecmean' char(`degree')  
                	local sub2 : di "strength " %2.0f 100 * `vecstr' "%" 
			
			if c(stata_version) >= 11 { 
				local sub3 "{it:n }= `N'"
			}
			else local sub3 "n = `N'" 

			local subtitle sub("`sub1' `sub2' `sub3'", pos(6) size(medium)) 

			if `ng' > 1 { 
				local which : label (`group') `g' 
				local title title(`"`which'"', pos(11) size(medlarge)) 
			}

			if "`resultant'" != "off" { 
				local resy = `vecstr' * cos(`vecmean'*_pi/180) 
				local resx = `vecstr' * sin(`vecmean'*_pi/180)  
				if "`reverse'" == "" { 
					local rescall pcarrowi 0 0 `resy' `resx', barbsize(medium) `resultant'
				}
				else local rescall pcarrowi `resy' `resx' 0 0, barbsize(medium) `resultant'
			} 

			tempfile this 

			// save each graph, but don't draw  
			twoway `rescall' ///
			|| pci `ctickcall', lcolor(blue) `addtext' `compass' /// 
			|| function sqrt(1 - x * x) , ra(-1 1) clw(medthin) clp(solid) clcolor(blue) `circle' ///  
			|| function -sqrt(1 - x * x), ra(-1 1) clw(medthin) clp(solid) clcolor(blue) `circle' ///  
			|| scatter `doty' `dotx' if `group' == `g', ms(oh) mcolor(orange) /// 
			plotregion(margin(zero) style(none)) legend(off) aspect(1) ///
			ysc(r(-`size' `size') off fill) xscale(r(-`size' `size') off fill) /// 
			yla(, nogrid) `subtitle' `title' `options' saving("`this'") nodraw ///
			// blank 

			local all `"`all' "`this'""' 
		} 
	}

	if `ng' == 1 graph use `this' 
	else graph combine `all', `byopts' 

	if `"`saving'"' != "" {
		graph save `saving' 
	}
end

* NJC 1.0.0 5 January 2004
program Clabelparse
	version 8.0
	local j = 0 
	while `"`0'"' != "" { 
		gettoken t 0 : 0, qed(q) 
	        if `q' { 
			if `j' == 0 | "`n_or_s_prev'" == "S" { 
				di as err "invalid clabel()"
				exit 198 
			} 
			else { 
				local S `"`S'`"`t'"' "' 
				local n_or_s_prev "S"
			} 
		} 
		else { 
			local ++j 
			local N "`N'`t' " 
			if "`n_or_s_prev'" == "N" { 
				local S `"`S'`"`prev'"' "' 
			} 
			local prev `t'
			local n_or_s_prev "N" 
		}
	}

	if "`n_or_s_prev'" == "N" local S `"`S'"`prev'""' 
	c_local clabelnumb `N'
	c_local clabeltext `"`S'"' 
end 

* 1.4.0 NJC 2 Apr 2009 
* 1.3.0 NJC 18 Dec 2003 
* 1.2.0 NJC 14 July 1998
program Atan2, rclass 
	version 8.0
	tempname at

	local s1 = sign(`1')
	local s2 = sign(`2')

	if (`s1' == 1 & `s2' == 1) | (`s1' == 0 & `s2' == 1) scalar `at' = atan(`1'/`2')
	else if `s1' == 1 & `s2' == 0  scalar `at' = _pi / 2
	else if `s1' == -1 & `s2' == 0 scalar `at' = 3 * _pi / 2
	else if `s2' ==  -1            scalar `at' = _pi + atan(`1'/`2')
	else if `s1' == -1 & `s2' == 1 scalar `at' = 2 * _pi + atan(`1'/`2')
	else if `s1' == 0 & `s2' == 0  scalar `at' = . 
	
	return scalar angle = (180 / _pi) * `at'
end

// label placement is inward of tick, e.g. South for tick at North. 
* 2.0.0 NJC 2 Apr 2009 
* 1.0.0 NJC 19 Dec 2003 
program Compasspoint 
	version 8 
	local 2 = 1 + round(`2',45)/45 
	local C : word `2' of s sw w nw n ne e se s
	c_local `1' "`C'" 
end 
  

* 1.0.0 NJC 2 April 2009 
program Parseby 
	version 8 
	syntax varname [, *] 
	c_local byvar `varlist' 
	c_local byopts `options' 
end 
