{smcl}
{* 22dec2003/4oct2005/6apr2009/15apr2009}{...}
{hline}
help for {hi:circvplot}
{hline}

{title:Cumulative vector plot for circular data}

{p 8 17 2}
{cmd:circvplot}
{it:varname}
[{cmd:if} {it:exp}] 
[{cmd:in} {it:range}]
[{it:weight}] 
[{cmd:,}
{cmdab:result:ant(}{it:resultant_options}{cmd:)} 
{cmdab:rev:erse} 
{cmdab:deg:ree(}{it:#}{cmd:)} 
{cmdab:rot:ate(}{it:#}{cmd:)}
{cmd:by(}{it:byvar} [{cmd:,} {it:combine_options}]{cmd:)} 
{cmd:saving(}{it:filename} [{cmd:,} {it:suboptions}]{cmd:)}  
{cmd:line(}{it:line_options}{cmd:)} 
{it:twoway_options} 
] 

{p 4 4 2}{cmd:fweight}s and {cmd:aweight}s are allowed; see {help weight}. 


{title:Description} 

{p 4 4 2} 
{cmd:circvplot} produces a cumulative vector plot for {it:varname}.
Vectors for each observation are
sorted and plotted end to end, by default starting opposite the mean
direction. The resultant of the vectors is also shown as an arrow. 

{p 4 4 2}
{it:varname} should take on values
with a range of 360 degrees. Thus, for example, a variable {cmd:m} containing months 
1,...,12 could be scaled {cmd:m * 30} or {cmd:(m - 1) * 30} or {cmd:(m - 0.5) * 30}. 


{title:Options}

{p 4 8 2}{cmd:resultant()} specifies options of {help twoway pcarrowi}
controlling the rendering of the
arrow showing the resultant. The default includes 
{cmd:barbsize(medium) mlw(medthick) lw(medthick) msize(medium)}. 

{p 4 8 2}{cmd:reverse} reverses the direction of the resultant arrow. 
This is intended as a convenience especially to users of wind data, for
whom a West wind is from the West, not to it. 

{p 4 8 2}{cmd:degree()} can be used to specify the character used to 
show the degree symbol for the vector mean if {cmd:circvplot}'s
default of 176 is not appropriate for your system. See {help char()}. 

{p 4 8 2}
{cmd:rotate()} changes the direction at which plotting starts by a
clockwise rotation of {it:#} degrees from the default of opposite the
vector mean. Such rotation is needed occasionally to avoid producing
a loop that cuts itself.

{p 4 8 2}
{cmd:by()} indicates that plots should be shown separately for the distinct groups of 
a variable {it:byvar}. Options of {help graph combine} may also be specified. Please note
that this is {bf:not} the standard graph {help by option}. 

{p 4 8 2} 
{cmd:saving()} saves the graph to a file; see {help saving option}. 

{p 4 8 2} 
{cmd:line()} may be used to specify options of {help twoway line} to tune rendering 
of the vectors. The default includes {cmd:lw(medthin) lp(solid)}. 

{p 4 8 2} 
{it:twoway_options} are other options of {help twoway} that may be
specified to tune other details of the graph. 
By default the {cmd:subtitle()} indicates the mean direction and vector 
strength and is {cmd:pos(6) size(medium)}. If two or more groups are shown 
under {cmd:by()} the {cmd:title()} indicates the group and is 
{cmd:pos(11) size(medium)}. The {cmd:title()} size is conservative to reduce the 
risk of crowding; those with short titles may wish to increase it. 


{title:Example} 

{p 4 8 2}{cmd:. circvplot wallasp, title("Wall aspect", pos(12))}{p_end}
{p 4 8 2}{cmd:. circvplot wallasp,  line(recast(connected)) by(grade)} 


{title:Author}

{p 4 4 2}
Nicholas J. Cox, Durham University, U.K.{break} 
n.j.cox@durham.ac.uk


{title:References} 

{p 4 8 2}
Batschelet, E. 1981. 
{it:Circular statistics in biology.} 
London: Academic Press. See p.9. 


{title:Also see}

{p 4 13 2} 
On-line: help for {help circdplot} (if installed),  
{help circrplot} (if installed), {help circpplot} (if installed)  

