cd \njc\stata8\circular\londontalk 

set scheme s1color 
clear 

twoway pcarrowi 0 0 10 1 0 0 10 -1, lw(*2) xsc(r(-10 10)) ysc(r(-10 10)) ysc(off) xsc(off) lc(blue) msize(*3) barbsize(large) mfcolor(blue) mlcolor(blue) || pcarrowi 0 0 -10.05 0, lw(*2) xsc(r(-10 10)) ysc(r(-10 10)) lc(orange) msize(*3) barbsize(large) mfcolor(orange) legend(off) text(5 2.5 "values", color(blue) size(*1.4)) text(-5 2.5 "mean?", color(orange) size(*1.4)) saving(london_means1, replace)

twoway pcarrowi 0 0 10 1 0 0 10 -1, lw(*2) xsc(r(-10 10)) ysc(r(-8 12)) ysc(off) xsc(off) lc(blue) msize(*3) barbsize(large) mfcolor(blue) mlcolor(blue) || pcarrowi 0 0 10.05 0, lw(*2) xsc(r(-10 10)) ysc(r(-8 12)) lc(orange) msize(*3) barbsize(large) mfcolor(orange) legend(off) text(5 2.5 "values", color(blue) size(*1.4)) text(11 0 "mean!", color(orange) size(*1.4)) saving(london_means2, replace)

graph use london_means1

graph save g1, asis replace

graph use london_means2

graph save g2, asis replace

u ..\cumbrian_cirques2009

circdplot axisasp , width(2) height(0.3) saving(dplot, replace)
graph save g3, asis replace 
graph use g3

circrplot axisasp , width(2) height(0.3) saving(rplot, replace)
graph save g4, asis replace 

circvplot axisasp, saving(vplot, replace)
graph save g5, asis replace 

circvplot axisasp, saving(vplot2, replace) by(grade, xcommon ycommon imargin(tiny))
graph save g6, asis replace

graph use svalbard_pplot_1
graph save g7, asis replace


gen axisasp2 = mod(axisasp + 135, 360)
histogram axisasp2, start(0) width(15) xla(45 "W" 135 "N" 225 "E" 315 "S") freq bcolor(ltblue) blcolor(ltblue*1.2) yla(, ang(h)) xtitle("Aspect of median axis")
graph save g8, asis replace

circhistogram axisasp, start(-180) width(15) xla(0 "N" 90 "E" 180 "S" 270 "W" 360 "N") bcolor(ltblue) blcolor(ltblue*1.2) yla(, ang(h)) xtitle("Aspect of median axis")
graph save g9, asis replace 

scatter wallasp axisasp, xla(0 "N"  90 "E" 180 "S" 270 "W" 360 "N") yla(0 "N"  90 "E" 180 "S" 270 "W" 360 "N", ang(h)) ytitle(aspect of headwall) xtitle(aspect of median axis) ms(Oh) mcolor(orange) aspect(1)
graph save g10, asis replace 

circscatter wallasp axisasp, xla(0 "N"  90 "E" 180 "S" 270 "W" 360 "N") yla(0 "N"  90 "E" 180 "S" 270 "W" 360 "N", ang(h)) ytitle(aspect of headwall) xtitle(aspect of median axis) ms(Oh) mcolor(orange) xcirc ycirc aspect(1)
graph save g11, asis replace 

graph use g12
graph use g13

circdplot axisasp, by(grade, imargin(tiny)) width(2)
graph save g14, asis replace 

graph use g15 

twoway function sin(_pi * x/180) , ra(0 360) lp(solid) || function cos(_pi * x/180), ra(0 360) lp(dash) xla(0 "N" 90 "E" 180 "S" 270 "W" 360 "N", grid) yla(, ang(h)) xtitle("") legend(off) lcolor(orange) text(0.9 135 "sine", color(dkgreen) size(*1.3)) text(-0.9 130 "cosine", color(orange) size(*1.3)) ytitle(sine and cosine)

graph save g16, asis

circfourier maxgrad wallasp, scatter(mcolor(gs12)) pairs(1/3) yla(, format(%2.0f)) xla(0 "N" 90 "E" 180 "S" 270 "W" 360 "N") xtitle(wall aspect) ytitle("maximum headwall gradient, {c 176}") legend(col(1) pos(3) symxsize(*0.5))

graph save g17, asis replace

circkdensity wallasp, h(45) lcolor(orange) addplot(histogram wallasp, start(0) width(30) bcolor(none) blcolor(dkgreen)) legend(off) xtitle(wall aspect) xla(0 "N" 90 "E" 180 "S" 270 "W" 360 "N")

graph save g18, replace asis

circksmooth maxgrad axgrad wallasp, addplot(scatter maxgrad axgrad wallasp, ms(O Oh) legend(order(3 "maximum" "headwall" - " " - " " - " " - " " - " " - ""  4 "axial")  pos(3) col(1))) h(60) ytitle("biweight smooth of gradients, {c 176}") xtitle(aspect of headwall) xla(0 "N" 90 "E" 180 "S" 270 "W" 360 "N")

graph use g19

graph use ..\kdensityvmiseswcauchy

graph save g20, asis replace

